config/routes.rb
Rails.application.routes.draw do
  
  devise_for :users

##############################################################################



  #####################
  #####################
  ##   APPLICATION   ##
  #####################
  #####################

  get 'ping' => 'table_tennis#ping'
  get 'ping_api' => 'table_tennis#ping_api'

  get 'help' => 'help#index'

  
  ################
  #   Accueils   #
  ################
  root "home#index"
  get "home", to: "home#index"
  get "admin", to: "home#admin"


  ###################
  #   Maintenances  #
  ###################
  resources :maintenance_ressources
  resources :maintenances
  get "grille_maintenances", to: "maintenances#grille"

  
  #############
  #   Tools   #
  #############
  get "tools", to: "tools#index"
  get "check_days", to: "tools#check_days"
  get "check_users", to: "tools#check_users"
  get "check_admins", to: "tools#check_admins"
  get "backup_db", to: "tools#backup_db"
  get "exports", to: "tools#exports"
  get "download_backup", to: "tools#download_backup"
  get "statistics", to: "tools#statistics"

  get "calculate", to: "tools#calculate"


  ####################
  #   Configuration  #
  ####################
  resources :konfigurations, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##############
  #   Ajouts   #
  ##############
  resources :ajouts, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "ajouts/:id/valider", to: "ajouts#valider"
  get "ajouts/:id/dupliquer", to: "ajouts#dupliquer"
  get "ajouts/:id/modification", to: "ajouts#modification"


  ################
  #   Template   #
  ################
  resources :templates, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ##############
  #   Groupes  #
  ##############
  resources :groupes, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##############
  #   Classes  #
  ##############
  resources :classes, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###############
  #   Services  #
  ###############
  resources :services, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###############
  #   messages  #
  ###############
  resources :messages, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###########
  #  Lieux  #
  ###########
  resources :lieus, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##################
  #  Bug Repports  #
  ##################
  resources :bug_repports, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###################
  #  Blog Messages  #
  ###################
  resources :blog_messages, only: [ :show, :index, :new, :edit, :create, :update, :destroy]
  resources :blog_responses, only: [ :new, :edit, :create, :update, :destroy ]
  resources :reviewcats, only: [ :show, :index, :new, :edit, :create, :update, :destroy]
  get "blog_message_export_pdf", to: "export#blog_message_export_pdf"
  get "review_blog_message", to: "blog_messages#review"

  ################
  #  Wiki Pages  #
  ################
  resources :wiki_pages, only: [ :show, :index, :new, :edit, :create, :update, :destroy]

  #############
  #  Postits  #
  #############
  resources :postits, only: [ :show, :index, :new, :edit, :create, :update, :destroy]
  get "take_it", to: "postits#take_it"
  get "done", to: "postits#done"

  #####################
  #  Blog Categories  #
  #####################
  resources :blog_categories, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###################
  #   Utilisateurs  #
  ###################
  resources :utilisateurs, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  #######################
  #  Absences & Congés  #
  #######################
  resources :absences, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "grille", to: "absences#grille"
  get "not_yet_validated_absences", to: "absences#not_yet_validated"
  get "validated_absences", to: "absences#validated"
  get "remove_one_day", to: "absences#remove_one_day"


  ################
  #  Fermetures  #
  ################
  resources :fermetures, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ############
  #  Events  #
  ############
  resources :events, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##########
  #  Logs  #
  ##########
  resources :logs, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  resources :log_repports, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]

  
  #####################
  #   Types Absences  #
  #####################
  resources :type_absences, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ############
  #   Jours  #
  ############
  resources :jours, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "today", to: "jours#specific_day"
  get "week", to: "jours#specific_week"
  get "month", to: "jours#specific_month"
  get "secr_pet", to: "jours#secr_pet"
  get "ical_export_ics", to: "export#ical_export_ics"


  ###################
  #   WorkingLists  #
  ###################
  resources :working_lists, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ############
  #   Works  #
  ############
  resources :works, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ############
  #   Tasks  #
  ############
  resources :tasks, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  #############
  #   Hebdos  #
  #############
  resources :hebdos, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "grille_hebdos", to: "hebdos#grille"


  ###################
  #   Productions   #
  ###################
  resources :productions
  resources :prod_units
  resources :prod_destinations
  resources :traceurs


  
  ######## TESTS
  get "show.pdf", to: "export#show"
  get "test", to: "test#index"


  ########## Export DB
  #get "exports", to: "export#index"
  get "logbook_articles_json", to: "export#logbook_articles_json"

end

app/controllers/home_controller.rb
class HomeController < ApplicationController

    # ACCUEIL
    def index
        session[:page_aide] = "index"
        
        # Log action
        log(request.path)

        fichier = "app/../last_git_date.txt"
        @last_git_date = File.exist?(fichier) ? format_last_git_date(File.read(fichier)) : @last_git_date = nil


        redirect_to "/users/sign_in" unless user_signed_in?

        # Check les jobs du user courant
        get_today if user_signed_in?

        #check les postits
        get_postits if user_signed_in?

        # Charge les dernières connections 
        get_lasts_connected if user_signed_in?

        # Nombre de bugs en attente
        get_bugs_in_queue if user_signed_in? 
        
    end

    private

    def get_bugs_in_queue
        if is_super_admin?
            @bugs_new = BugRepport.where(status: "outlined_flag").size
            @bugs_test = BugRepport.where(status: "sync_problem").size
        end
    end

    def get_postits
        @postits = Postit.order(level: :desc)
    end

    def format_last_git_date(dt)
        formatted = dt
        unless dt.nil?
            formatted = dt.split[1..-2]
        end
        formatted.to_sentence
    end

    def get_lasts_connected
        if is_super_admin?
            @last_connects = User.where.not(last_connection: nil).order(last_connection: :desc).limit(5)
        end
    end

    def get_today
        # Log action
        log(request.path, "Get Horaire du jour")
        @specific_day_works = Hash.new
        @absence = Hash.new

        # Détermine la date
        @specific_day_jours = Jour.today_of(current_user.utilisateur.id)

        # Parse les jours
        @specific_day_jours.each do |jour|
            @specific_day_works[jour] = WorkingList.for(jour)
        end

        # Check les absences
        @absence = false
        abs = Absence.today_for_user(current_user.utilisateur)
        if abs.count > 0
            @absence = abs
        end

        # Charge les Events
        @events = Hash.new
        charge_events(Date.today, current_user.utilisateur.service)

        # Charge les messages
        @messages = Array.new
        charge_messages(Date.today)

        # Charge les tâches
        find_tasks(current_user.utilisateur, true)
    end
end

app/views/home/_barre_menu.html.erb
<div class="container-fluid">
    <div class="row">


        <!-- Calendriers -->
        <div class="col-sm-6 col-md-4">
            <div class="btn-group btn-group-justified">
                <a href="<%= today_path %>" class="btn btn-xs btn-primary" role="button">
                    <i class="material-icons">today</i><br>
                    Today
                </a>
                <a href="<%= week_path %>" class="btn btn-xs btn-primary" role="button">
                    <i class="material-icons">date_range</i><br>
                    This Week
                </a>
                <a href="<%= month_path %>" class="btn btn-xs btn-primary" role="button">
                    <i class="material-icons">calendar_today</i><br>
                    This Month
                </a>
            </a>
                
            </div>
        </div>


        <!-- Absences -->
        <div class="col-sm-6 col-md-4">
            <div class="btn-group btn-group-justified">
                <a href="<%= absences_path %>" class="btn btn-xs btn-success" role="button">
                    <i class="material-icons">healing</i><br>
                    <%= I18n.t("home.index.absences") %>
                </a>
                <a href="<%= grille_path %>" class="btn btn-xs btn-success" role="button">
                    <i class="material-icons">healing</i><br>
                    <%= I18n.t("home.index.grille") %>
                </a>
                <!-- Events, days off et types absences -->
                <a href="<%= fermetures_path %>" class="btn btn-xs btn-success" role="button">
                    <i class="material-icons">event_busy</i><br>
                    <%= I18n.t("home.index.fermetures") %>
                </a>
                <a href="<%= events_path %>" class="btn btn-xs btn-success" role="button">
                    <i class="material-icons">event_available</i><br>
                    <%= I18n.t("home.index.evenements") %>
                </a>
            </div>
        </div>
    

        <!-- Boutons BLOG, WIKI, etc -->
        <div class="col-sm-6 col-md-4">
            <div class="btn-group btn-group-justified">
                <a href="<%= bug_repports_path %>" class="btn btn-xs btn-info" role="button">
                    <i class="material-icons">bug_report</i><br>
                    Bugs
                </a>
                <a href="<%= blog_messages_path %>" class="btn btn-xs btn-info" role="button">
                    <i class="material-icons">rss_feed</i><br>
                    <%= I18n.t("home.index.blog").upcase %>
                </a>
                <a href="<%= postits_path %>" class="btn btn-xs btn-info" role="button">
                    <i class="material-icons">dynamic_feed</i><br>
                    <%= I18n.t("postits.index.titre") %>
                </a>
                <a href="<%= grille_hebdos_path %>" class="btn btn-xs btn-danger" role="button">
                    <i class="material-icons">settings_ethernet</i><br>
                    <%= I18n.t("home.index.grille_hebdos") %>
                </a>
                <a href="<%= calculate_path %>" class="btn btn-xs btn-info" role="button">
                <i class="material-icons">calculate</i><br>
                Calculate
            </a>
            </div>
        </div>

    </div>
</div>

app/views/home/_barre_menu_rapide.html.erb
<div class="container-fluid">
    <div class="row">

        <div class="col">
            <div class="btn-group btn-group-justified">
                <a href="<%= not_yet_validated_absences_path %>" class="btn btn-xs btn-success" role="button">
                    <i class="material-icons">healing</i><br>
                    <%= I18n.t("home.index.waiting") %>
                </a>
                
            
                <a href="<%= utilisateurs_path %>" class="btn btn-xs btn-primary" role="button">
                    <i class="material-icons">group</i><br>
                    <%= I18n.t("home.index.utilisateurs") %>
                </a>
                <a href="<%= ajouts_path %>" class="btn btn-xs btn-primary" role="button">
                    <i class="material-icons">playlist_add</i><br>
                    <%= I18n.t("home.index.batchs") %>
                </a>
            
                <a href="<%= hebdos_path %>" class="btn btn-xs btn-danger" role="button">
                    <i class="material-icons">settings_ethernet</i><br>
                    <%= I18n.t("home.index.hebdos") %>
                </a>
                <a href="<%= maintenances_path %>" class="btn btn-primary" role="button">
                    <i class="material-icons">engineering</i><br>
                    maintenances
                </a>
            </div>
        </div>
    </div>
</div>

<hr />

app/views/home/_comm_absences.html.erb
<% if @absence %>
    <span class="label label-success"><%= I18n.t("home.index.absences") %></span>
    <% @absence.each do |abs| %>
        <%= I18n.localize abs.date, format: :long %>
        <% if abs.date_fin != abs.date %>
                - 
            <%= I18n.localize abs.date_fin, format: :short %> (<%= (abs.date_fin - abs.date + 1).to_i %>)
        <% end %>
    <% end %>
<% end %>

app/views/home/_comm_events.html.erb
<% if @events and @events[current_user.utilisateur.service.id] %>
    <% @events[current_user.utilisateur.service.id].each do |event| %>
        <span class="label label-default"><%= event.service.nom %></span>
        <%= event.nom %><%= " : #{event.note}" if event.note %>
    <% end %>
<% end %>

app/views/home/_comm_messages.html.erb
<% if @messages %>
    <% @messages.each do |message| %>
        <% if (message.service == current_user.utilisateur.service) or is_super_admin? %>
            <span class="label label-primary"><%= message.service.nom %></span>
            <%= message.note.capitalize %>
        <% end %>
    <% end %>
<% end %>

app/views/home/_comm_tasks.html.erb
<% if @tasks[Date.today.cweek] %>
    <%= "TASK : " %>
    <% @tasks[Date.today.cweek].each do |tsk| %>
        <%= "<span class='label label-warning'
            data-toggle='tooltip' 
            title='#{tsk.last}'>
            #{link_to tsk.first, hebdos_path()}
            </span>&nbsp;".html_safe
        %>
    <% end %>
<% end %>

app/views/home/_header.html.erb
<div class="jumbotron">
    <div class="container">
        <h1 class="display-4">ORGA</h1>
        <p class="lead">
            <%= "#{I18n.t("home.index.welcome")} #{current_user.utilisateur.prenom if (user_signed_in? && current_user.utilisateur) }".upcase %>
        </p>
    </div>
</div>

app/views/home/_jobs_boxes_today.html.erb
<% last_service = nil %>

<% @specific_day_jours.each do |specific_day_jour| %>

    <div class=" col-md-4">
        <% panel = "default" %>
        <% panel = "success" if @absence %>

        <div class="panel panel-<%= panel %>">

            <!-- HEADING PANEL -->
            <div class="panel-heading">
                <i class="material-icons">business</i>
                <%= specific_day_jour.service.nom.upcase %>
            </div>

            <!-- CONTENT PANEL -->
            <div class="panel-body">

                <p>
                    AM : 
                    &nbsp;&nbsp;&nbsp;
                    <% unless specific_day_jour.am_pm %>
                        <% @specific_day_works[specific_day_jour].each do |wl| %>
                            <% cl = "" %>
                            <% if wl.work.code.downcase=="qc" && Date.today.cwday==5 %>
                                <% cl = "keep_attention" %>
                            <% end %>
                            <span class="label label-primary <%= cl %>"
                                data-toggle="tooltip" 
                                title='<%= "#{wl.work.nom}" %>'
                            >
                                <%= wl.work.code %>
                            </span>
                            &nbsp;
                        <% end %>
                    <% else %>
                        ---
                    <% end %>
                    <br>
                    PM : 
                    &nbsp;&nbsp;&nbsp;
                    <% if specific_day_jour.am_pm %>
                        <% @specific_day_works[specific_day_jour].each do |wl| %>
                            <% cl = "" %>
                            <% if wl.work.code.downcase=="qc" && Date.today.cwday==5 %>
                                <% cl = "keep_attention" %>
                            <% end %>
                            <span class="label label-info <%= cl %>"
                                data-toggle="tooltip" 
                                title='<%= "#{wl.work.nom}" %>'
                            >
                                <%= wl.work.code %>
                            </span>
                            &nbsp;
                        <% end %>
                    <% else %>
                        ---
                    <% end %>
                </p>

                <p class="text-danger"><%= specific_day_jour.note %></p>

            </div>

            <!-- FOOTER PANEL -->
            <div class="panel-footer">
                <% unless @events[specific_day_jour.service.id].nil? %>
                    <% @events[specific_day_jour.service.id].each do |event| %>
                        <span class="badge"
                            data-toggle="tooltip" 
                            title="<%= event.note %>"
                        >
                        <%= event.nom.capitalize %>
                        </span>
                    <% end %>
                <% end %>
            </div>
        </div>
    </div>
<% end %>

app/views/home/_last_connects.html.erb
<br><div class="row">
    <div class="well well-sm">
        Lately connected : 
        <% @last_connects.each do |last_connect| %>
            <% unless last_connect.utilisateur.nil? and last_connect.last_connection.nil? %>
                <%= last_connect.utilisateur.prenom_nom %> (<%= time_ago_in_words(last_connect.last_connection) %>) &nbsp;&nbsp;&nbsp;
            <% end %>
        <% end %>
    </div>
</div>

app/views/home/_left_box.html.erb
<div class="col-md-4">

    <article>

        <!-- Tâches -->
        <article><%= render partial: "comm_tasks" %></article>

        <!-- Messages -->
        <article><%= render partial: "comm_messages" %></article>

        <!-- Absences -->
        <article><%= render partial: "comm_absences" %></article>
        
        <!-- Events -->
        <article><%= render partial: "comm_events" %></article>
        
    </article>
    
    <br>
</div>

app/views/home/_no_job_today.html.erb
<div class=" col-md-4">

    <div class="panel panel-default">

        <div class="panel-heading"></div>

        <div class="panel-body">

            <article class="text-muted">

                <%= I18n.t("home.index.no_schedule") %>
                
            </article>

        </div>

        <div class="panel-footer"></div>

    </div>

</div>

app/views/home/_postits.html.erb
<div class="container-fluid">
    <div class="row">
        <% @postits.each do |postit| %>
            <% if !(postit.level == 0 && (postit.done_at != Date.today)) %>
                <% if (postit.is_private && current_user.utilisateur == postit.utilisateur) || !postit.is_private %>
                    <div class="col-lg-2 col-md-3 col-sm-4 col-xs-6">

                        <% bg ||= "warning" %>
                        <% bg = "danger" if postit.is_private %>
                        <% bg = "default" if postit.level == 0 %>
                        
                        <div class="panel panel-<%= bg %>">
                            <div class="panel-heading home-postit">
                                <%= postit.title %>
                                
                                <% if postit.level > 1 %>
                                    <% mark = "*" %>
                                    <% level_color = postit.level_color %>
                                    <% colorTypo = "" %>

                                    
                                    <% if postit.level == 3 %>
                                        <% peremption = (postit.created_at.to_date + 15.days) %>
                                        <% level_color = "danger" if Date.today >= peremption %>
                                    <% end %>

                                    <% if postit.level == 4 %>
                                        <% peremption = (postit.created_at.to_date + 7.days) %>
                                        <% if Date.today >= peremption %>
                                            <% level_color = "danger" %>
                                            <% mark = "OUTDATED! #{peremption}" %>
                                            <% colorTypo = "text-danger" %>
                                        <% end %>
                                    <% end %>

                                    <span class="label label-<%= level_color %>"><%= mark %></span>
                                <% end %>
                                
                                <span class="<%= colorTypo %>"><%= postit.body %></span>

                                <small>(<%= postit.utilisateur.initiales %>)</small>
                            </div>  

                            <% if postit.level != 0 %>
                                <div class="btn-group btn-group-justified bg-warning">
                                    <% if postit.level != 2 && postit.is_private != true %>
                                        <%= 
                                            link_to "[Take]", 
                                            take_it_path(id: postit), 
                                            data: { 
                                                confirm: "Are you sure you want to be in charge for this Post-It task ?"
                                            },
                                            class: "btn btn-xs btn-link text-warning" 
                                        %>
                                    <% end %>


                                    <% if postit.level == 2 or postit.is_private %>
                                        <% if (postit.is_private) or (postit.is_private != true and postit.taken.id == current_user.utilisateur.id) %>

                                            <%= 
                                                link_to "[Done!]", 
                                                done_path(id: postit), 
                                                data: { 
                                                    confirm: "Are you confirming that this task is done ?"
                                                },
                                                class: "btn btn-xs btn-link text-warning"
                                            %>
                                            
                                        <% else %>
                                            <small class="text-muted">
                                                Taken by <%= postit.taken.prenom if !postit.taken.nil? %>
                                            </small>
                                        <% end %>
                                    <% end %>
                                </div>
                            <% end %>
                        </div>
                    </div>
                <% end %>
            <% end %>
        <% end %>
    </div>
</div>

app/views/home/_today.html.erb
<% date_localized = "#{nom_jour(Date.today.cwday)} #{I18n.localize Date.today, format: :long}" %>
<div class="panel panel-default">

    <div class="panel-heading">
        <h4 class="text-info"><%= date_localized %></h4>
    </div>

    <div class="panel-body">
        <div class="row">

            <!-- Première boîte à gauche -->
            <%= render partial: "left_box" %>
            
            <!-- Jobs de l'utilisateur -->
            <% if @specific_day_jours.nil? or @specific_day_jours.size < 1 %>

                <!-- Si pas de job aujourd'hui -->
                <%= render partial: "no_job_today" %>
                
            <% else %>

                <!-- S'il y a des jobs aujourd'hui -->
                <%= render partial: "jobs_boxes_today" %>

            <% end %>
        </div>
    </div>
</div>

app/views/home/index.html.erb
<div class="container">

    <!-- HEADER -->
    <%= render "header" %>

    <% if user_signed_in? %>

        <!-- TODAY -->
        <%= render "today" %>

        <!-- ADMIN MENU -->
        <%= render "barre_menu_rapide" if is_super_admin? %>
        
        <!-- MENU -->
        <%= render "barre_menu" %>

        <br />

        <%= render partial: "postits" %>

        <hr />

        <!-- Barre Managers -->
        <%= render partial: "barre_menu_manager" if is_manager? %>

        <br />

        <!-- CONNECTED -->
        <%= render "last_connects" if is_super_admin? %>

        <!-- BUGS -->
        <% if is_super_admin? %>
            <p>
                <%= "#{@bugs_new} new bug(s)." if @bugs_new > 0 %> 
                <%= "#{@bugs_test} bug(s) on test." if @bugs_test > 0 %>
            </p>
        <% end %>
    <% end %>
</div>